//*****************************************************************************
//                    Laborprojekt, FH-Wedel 2005
//-----------------------------------------------------------------------------
//
// Modul:       - Diese Headerdatei definiert Konstanten und Werte fr die
//                programminternen USB-Befehle zur Kommunikation zwischen
//                Firmware und dem Windows-Programm
//
//-----------------------------------------------------------------------------
// Datum:       Copyright 2005, Andreas Schibilla
//*****************************************************************************
#ifndef _COMMANDS_H_
#define _COMMANDS_H_


#define C_VERSION             "1.00"  
#define C_ERR_PACKETLENGTH    "Error: Command too short!"
#define C_ERR_SIGNATURE       "Error: Command with wrong signature!"
#define C_ERR_UNKNOWN         "Error: Unknown command!"

#define CMD_ERASE             0x01
#define CMD_BLANK_CHECK       0x02
#define CMD_PROGRAM           0x03
#define CMD_VERIFY            0x04
#define CMD_SET_LOCK          0x07

#define CMD_GET_VERSION       0x20
#define CMD_GET_TYPE          0x21

#define CMD_ERROR_STR         0x30
#define CMD_HEXDATA           0x40
#define CMD_DEBUG             0x50

#define PACKET_SIZE           64
#define PACKET_SIG            'A'
#define PACKET_HEADER_LEN     2


#endif  // _COMMANDS_H_       

