//*****************************************************************************
//                    Laborprojekt, FH-Wedel 2005
//-----------------------------------------------------------------------------
//
// Programm:    - Dieses Modul enthlt den Einstiegspunkt (main) des Mikro-
//                Controller Programms (Firmware) fr den AT89C5131, der
//                die Steuerung des Flash-Vorgangs bernimmt
//
//-----------------------------------------------------------------------------
// Datum:       Copyright 2005, Andreas Schibilla
//*****************************************************************************
#include "at89c5131.h"
#include "ext_5131.h"
#include "compiler.h"
#include "usb.h"       
#include "flash.h"

 
   
//*****************************************************************************
// Funktion:    Eintrittsfunktion der Firmware
//              Initialisiert Ports, Interrupts, LEDs, PLL und USB
//              Hlt das Programm in einer Endlosschleife
//-----------------------------------------------------------------------------
// Parameter:   -
// Return:      -
//-----------------------------------------------------------------------------
// Datum:       2005-04-11, Andreas Schibilla
//*****************************************************************************
void main(void)
{
 
 // Interrupts initialiseren
 IT0        = 0;        // Interrupt0 flankengetriggert (TCON, Bit 0)
 IE0_       = 0;        // Flag von Interrupt0 zurcksetzen (TCON, Bit 1)
 EX0        = 1;        // externen Interrupt0 freigeben
 EA         = 0;        // Interrupts noch nicht freigeben

 // LED's initialisieren
 LEDCON     = 0xFF;     // alle vier LEDs auf 10mA Stromquellen
 LED_POWER  = 0;        // Betriebslampe an
 LED_BUSY   = 1;        // die anderen beiden LEDs aus
 LED_ERROR  = 1;  
 P3_7       = 1;
 
 // Zeige an, das Controller initialisiert wird
 LED_BUSY   = 0;        // BUSY LED
 
 // Port P0,P1,P2 und P3 initialiseren (alle Pins auf High)
 P0         = 0xFF;                
 P1         = 0xFF;                
 P2         = 0xFF;
 P3_0       = 1;
 P3_1       = 1;  
 P3_4       = 1;  
 P2_2       = 1;  

 // PLL auf 48MHz fr USB einstellen
 usb_init_pll();

 // USB-Einheit initialisieren und Interrupts freigeben
 usb_init();
 
 // Initialisierung vorbei
 LED_BUSY = 1;    // READY LED
 
 // Halte Mikrocontroller in Endlosscheife
 while (1)   { ; }

}
  
