//*****************************************************************************
//                    Laborprojekt, FH-Wedel 2005
//-----------------------------------------------------------------------------
//
// Modul:       - enthlt Funktionen zum Abschicken und Empfangen 
//                der Programmerbefehle
//
//-----------------------------------------------------------------------------
// Datum:       Copyright 2005, Andreas Schibilla
//*****************************************************************************
#ifndef _COMMANDS_H_
#define _COMMANDS_H_


#define C_VERSION             "1.00"  
#define C_ERR_PACKETLENGTH    "Error: Command too short!"
#define C_ERR_SIGNATURE       "Error: Command with wrong signature!"
#define C_ERR_UNKNOWN         "Error: Unknown command!"


#define CMD_ERASE             0x01
#define CMD_BLANK_CHECK       0x02
#define CMD_PROGRAM           0x03
#define CMD_VERIFY            0x04
#define CMD_SET_LOCK          0x07

#define CMD_GET_VERSION       0x20
#define CMD_GET_TYPE          0x21

#define CMD_ERROR_STR         0x30
#define CMD_HEXDATA           0x40
#define CMD_DEBUG             0x50

#define PACKET_SIG            'A'
#define PACKET_HEADER_LEN     2



#define C_SIG_ATMEL           "Atmel"
#define C_SIG_ATMEL_ID        0x1E
#define C_SIG_UNKNOWN         "unbekannt"


#define C_SIG_1051            "89C1051"
#define C_SIG_1051U           "89C1051 U"
#define C_SIG_2051            "89C2051"
#define C_SIG_4051            "89C4051"

#define C_MAX_FLASH_SIZE      4096

typedef struct st_signature
{
 unsigned char  mfr;
 unsigned char  art;
 unsigned short flashsize;

 char     version_str[100];
 char     mfr_str[100];
 char     art_str[100];

} t_signature;


typedef struct st_packet
{
 unsigned char  sig;
 unsigned char  command;
 unsigned char  data[PACKET_SIZE-2];
 size_t         len;

} t_packet;


typedef struct st_hex_record
{
 unsigned char  len;
 unsigned short addr;
 unsigned char  type;
 unsigned char  data[PACKET_SIZE-4];

} t_hex_record;


typedef struct st_mem
{
 unsigned char  data[C_MAX_FLASH_SIZE];
 BOOL           enable[C_MAX_FLASH_SIZE];

} t_mem;



BOOL isBinFile(char *filename, DWORD *dwSize);
BOOL isHexFile(char *filename);

BOOL ReadHexRecord(t_hex_record *hr, char *p, size_t max);

int chip_type_and_version(t_signature *sig);
int chip_erase(void);
int chip_blank_check(void);
int chip_program(char *hexfile, BOOL isHex, unsigned char command);
//int chip_verify(char *hexfile);
int chip_read_hex(char *hexfile);
int chip_set_lockbits(unsigned char lb);

int chip_debug(void);
BOOL read_hexfile(char *hexfile, t_mem *m, int flashsize);


#endif  // _COMMANDS_H_       




